C A code to calculate the beam-charge asymmetry

      program dHOSE            
      implicit double precision (a-h,o-z)
c      dimension z(100),wz(100)
      
      pi=acos(-1.0)

C External kinematics
      En=100.0  
      Q2=6.0
      xB=0.1
      aJu=0.0d0

      Theta=1.0  
      call LABSYS(En,Q2,xB,Theta,t)

        write(6,*) 'E_lepton (GeV) =',En
        write(6,*) 'Q**2 (GeV**2) =',Q2
        write(6,*) 'xB =',xB
        write(6,*) 'Theta (deg) =',Theta
        write(6,*) 't (GeV) =',t
      
C Integration over phi	
c      Nz=100
c      pi=acos(-1.0)		
c      z_min=0.
c      z_max=2.*pi
		
c      call gausab(z,wz,z_min,z_max,Nz)
c      aut0=0.0    
c      do i=1,N
c        aut0=aut0+aint0(z(i))*wz(i)
c      enddo
		
c		write(*,*) aut0

        phi_min=0.0
        phi_max=pi

        Np=10
        do i=1,Np
        phi=phi_min+(phi_max-phi_min)
     >*(i-1.)/(Np-1.)        
        
        call BEAM_CHARGE(En,Q2,xB,t,phi,AC)

        write(6,*) phi*180.0/pi,AC
        
        enddo
        
        stop
     	end


        subroutine LABSYS(En,Q2,xB,Theta,t)
        implicit double precision (a-h,o-z)

        amn=0.938272
        pi=acos(-1.0)

C Photon energy
        anu=Q2/(2.*amn*xB)

C Photon momentum
        aq=(anu**2+Q2)**0.5

        t=(-Q2-2.0*anu**2+2.0*anu*aq*cos(pi/180.0*Theta))
     >/(1.0+anu/amn-aq/amn*cos(pi/180.0*Theta)) 

        return
        end
      

        subroutine BEAM_CHARGE(En,Q2,xB,t,phi,AC)
        implicit double precision (a-h,o-z)

        call KINEM(En,Q2,xB,t,eps1,y1,tmin,aK1)
        call PROPAGATORS(En,Q2,xB,t,phi,P1,P2)

        call BH_unp(En,Q2,xB,t,
     >c0_BH_unp,c1_BH_unp,c2_BH_unp)

        call aInt_unp(En,Q2,xB,t,
     >cI0_unp,cI1_unp,cI2_unp)

        call DVCS_unp(En,Q2,xB,t,
     >cD0_unp,cD1_unp)

C Forming the asymmetry

c       cD0_unp=0.0
c       cD1_unp=0.0
c       cI0_unp=0.0
c       cI2_unp=0.0
c       c1_BH_unp=0.0
c       c2_BH_unp=0.0 

      a_I=
     >cI0_unp-cI1_unp*cos(phi)+cI2_unp*cos(2.*phi)

      a_BH=
     >c0_BH_unp-c1_BH_unp*cos(phi)+c2_BH_unp*cos(2.*phi)

      a_DVCS=cD0_unp-cD1_unp*cos(phi)

C The beam-charge asymmetry

      AC=a_I
     >/(y1/(xB*(1.+eps1**2)**2)*a_BH
     >+xB*y1*t*P1*P2/Q2*a_DVCS)
       
        return
        end
      

C Electromagnetic form factors
        subroutine EM(t,F1,F2)
        implicit double precision (a-h,o-z)

        amn=0.938272

      F1=(1.+Abs(t)/0.71)**(-2)
     >*(1.-t*1.793/(4.*amn**2)*(1.-t/(4.*amn**2))**(-1))
          
      F2=1.793*(1.+Abs(t)/0.71)**(-2)*(1.-t/(4.*amn**2))**(-1)

        return
        end

c Unpolarized  BH amplitude squared

        subroutine BH_unp(En,Q2,xB,t,
     >c0_BH_unp,c1_BH_unp,c2_BH_unp)
        implicit double precision (a-h,o-z)

        amn=0.938272

        call KINEM(En,Q2,xB,t,eps,y,tmin,aK)
        call EM(t,F1,F2)

        Comb1=F1**2-t/(4.*amn**2)*F2**2
        Comb2=(F1+F2)**2

        c0_BH_unp=
     >8.*aK**2*((2.+3.*eps**2)*Q2/t*Comb1+2.*xB**2*Comb2)
     >+(2.-y)**2*((2.+eps**2)*(4.*xB**2*amn**2/t*(1.+t/Q2)**2
     >+4.0*(1.-xB)*(1.+xB*t/Q2))*Comb1
     >+4.*xB**2*(xB+(1.-xB+0.5*eps**2)*(1.-t/Q2)**2
     >-xB*(1.-2.0*xB)*t**2/Q2**2)*Comb2)
     >+8.*(1.+eps**2)*(1.-y-0.25*y**2*eps**2)
     >*(2.0*eps**2*(1.-t/(4.*amn**2))*Comb1
     >-xB**2*(1.-t/Q2)**2*Comb2)

       c1_BH_unp=
     >8.*aK*(2.-y)*((4.*xB**2*amn**2/t-2.*xB-eps**2)*Comb1
     >+2.*xB**2*(1.-(1.-2.*xB)*t/Q2)*Comb2)

       c2_BH_unp=
     >8.*xB**2*(aK)**2*(4.*amn**2/t*Comb1+2.0*Comb2)

        return
        end

c Unpolarized  Interference 
        subroutine aInt_unp(En,Q2,xB,t,
     > cI0_unp,cI1_unp,cI2_unp)
        implicit double precision (a-h,o-z)

        amn=0.938272

        call KINEM(En,Q2,xB,t,eps,yk,tmin,aK)
        call EM(t,F1,F2)

C Proton spin fraction due to the u-quark
        aJu=0.0
        call Dual(xB,Q2,t,aJu,Hscript_Im,Hscript_Re,
     >Escript_Im,Escript_Re)

             
      cI0_unp=
     >-8.*(2.-yk)*((2.-yk)**2/(1.-yk)*aK**2
     >*(F1*Hscript_Re-t/(4.*amn**2)*F2*Escript_Re)
     >+t/Q2*(1.-yk)*(2.-xB)
     >*(F1*Hscript_Re-t/(4.*amn**2)*F2*Escript_Re
     >-xB**2/(2.-xB)**2
     >*(F1+F2)*(Hscript_Re+Escript_Re)))

C***    c^{I}_{1,unp}     
     
      cI1_unp=
     >-8.*aK*(2.-2.*yk+yk**2)
     >*(F1*Hscript_Re-t/(4.*amn**2)*F2*Escript_Re)

C***    c^{I}_{2,unp}     
     
      cI2_unp=
     >-16.*aK**2*(2.-yk)*(-xB)
     >*(F1*Hscript_Re-t/(4.*amn**2)*F2*Escript_Re)

        return
        end

c Unpolarized DVCS squared
        subroutine DVCS_unp(En,Q2,xB,t,
     >cD0_unp,cD1_unp)
        implicit double precision (a-h,o-z)

        amn=0.938272

        call KINEM(En,Q2,xB,t,eps,yk,tmin,aK)

C Proton spin fraction due to the u-quark
        aJu=0.0
        call Dual(xB,Q2,t,aJu,Hscript_Im,Hscript_Re,
     >Escript_Im,Escript_Re)

C***    c^{DVCS}_{0,unp}     
     
      cD0_unp=
     >2.*(2.-2.*yk+yk**2)*1./(2.-xB)**2*(4.*(1.-xB)
     >*(Hscript_Im**2+Hscript_Re**2)-xB**2
     >*(2.*Hscript_Re*Escript_Re+2.*Hscript_Im*Escript_Im)
     >-(xB**2+(2.-xB)**2*t/(4.*amn**2))
     >*(Escript_Im**2+Escript_Re**2))
     
C***    c^{DVCS}_{1,unp}     
     
      cD1_unp=
     >8.*aK/(2.-xB)*(2.-yk)*1./(2.-xB)**2*(-xB)
     >*(4.*(1.-xB)*(Hscript_Im**2+Hscript_Re**2)
     >-xB**2*(2.*Hscript_Re*Escript_Re
     >+2.*Hscript_Im*Escript_Im)
     >-(xB**2+(2.-xB)**2*t/(4.*amn**2))
     >*(Escript_Im**2+Escript_Re**2))

        return
        end


C Lepton propagators
        subroutine PROPAGATORS(En,Q2,xB,t,phi,P1,P2)

        implicit double precision (a-h,o-z)

        call KINEM(En,Q2,xB,t,eps,yk,tmin,aK)
      
      aJ=(1.-yk-yk*eps**2/2.)*(1.+t/Q2)-(1.-xB)*(2.-yk)*t/Q2
      
      P1=-1./(yk*(1.0+eps**2))*(aJ+2.*aK*Cos(phi))

      P2=1.+t/Q2-P1

        return
        end

C Some kinematic factors

      subroutine KINEM(En,Q2,xB,t,eps,yk,tmin,aK)
      implicit double precision (a-h,o-z)
      
C Proton mass
      amn=0.938272
      
C eps = 2 xB M/Q
      eps=2.*xB*amn/Sqrt(Q2)
		
C y = Q^2 / (s*xB)
      s=2.0*En*amn+amn**2
      yk=Q2/(2.*xB*amn*En)
		
C tmin
      tmin=-Q2*(2.*(1.-xB)*(1.-Sqrt(1.+eps**2))+eps**2)
     >/(4.*xB*(1.-xB)+eps**2)
		
C K-factor
      aK=Sqrt(-t/Q2*(1.-xB)*(1.-yk-yk**2*eps**2/4.)*(1.-tmin/t)
     >*(Sqrt(1.+eps**2)+((4.*xB*(1.-xB)+eps**2)/(4.*(1.-xB))
     >*(t-tmin)/Q2)))
	  
      return
      end

C***********************************************************************

* Vadim Guzey, Ruhr-Universitaet, Bochum, Germany
* Email: vadim.guzey@tp2.ruhr-uni-bochum.de
* February, 2007

* Double precision FORTRAN code for PDFs H AND E convoluted with 
* Leading Order hard coefficient functions (H_script and E_script)
* and summed with quark charges squared 
* (LO expressions entering DVCS observables)
* in the DUAL parameterization of GPDs
* V. Guzey and T. Teckentrup, Phys.Rev.D74 (2006) 054027 [hep-ph/0607099] 

* IMPORTANT: Used non-factorizable, Regge-motivated model for the t-dependence
* (see the paper for details).

* For given values of xB (0.01 < xB < 0.5), Q**2 (1 < Q**2 < 10 GeV**2),
* t (0.005 < |t| < 1 GeV**2) and J_u=0, 0.2 and 0.4, 
* the code gives the imaginary and real parts of H_script and E_script

* HOW TO USE THE CODE

* The code performs 3D linear interpolations using grids supplied by the 
* data files Hscript_dual_guidal.dat, Escript_dual_guidal_Ju00.dat,
* Escript_dual_guidal_Ju02.dat, Escript_dual_guidal_Ju04.dat.
* The data files should be stored in the same directory with the code.

* An example of the use is given below: 
* The main subroutine Dual is called with given Ju (aJu), 
* Bjorken x (xB), Q**2 (Q2) and t. The subroutine outputs
* Hscript_Im (the imaginary part of H_script), etc.


      subroutine Dual(xB,Q2,t,aJu,Hscript_Im,Hscript_Re,
     >Escript_Im,Escript_Re)
      implicit double precision (a-h,o-z)

* Arrays of variables from the read data files
      dimension xB_array(27),Q2_array(19),t_array(13),
     >Hscript_Re_array(13,27,19),Hscript_Im_array(13,27,19)

* Temporary arrays used for 3D interpolation
      dimension Q2tmp_Im(19),Q2tmp_Re(19),xBtmp_Im(27),
     >xBtmp_Re(27),ttmp_Im(13),ttmp_Re(13)

* The same for the GPD E
      dimension Q2E_array(10),Escript_Re_array(13,27,10),
     >Escript_Im_array(13,27,10)

      dimension Q2Etmp_Im(10),Q2Etmp_Re(10),xBEtmp_Im(27),
     >xBEtmp_Re(27),tEtmp_Im(13),tEtmp_Re(13)

      common /Dual_Data/xB_array,Q2_array,t_array,
     >Hscript_Re_array,Hscript_Im_array,Q2E_array,
     >Escript_Re_array,Escript_Im_array

* Reading the data files (only once)
c      data iread/0/

c      if (iread.eq.0) then

      open(1,file='Hscript_dual_guidal.dat',status='unknown')

      Nt=13
      Nx=27
      Nq=19     

      do it=1,Nt
      do ix=1,Nx
      do iq=1,Nq

      read(1,*)xB_array(ix),Q2_array(iq),t_array(it),
     >Hscript_Im_array(it,ix,iq),Hscript_Re_array(it,ix,iq)

      enddo
      enddo
      enddo

      close(1)

c      iread=1  

      if (aJu.eq.0.d0) then
      open(2,file='Escript_dual_guidal_Ju00.dat',status='unknown')

      Nt=13
      Nx=27
      NqE=10     

      do it=1,Nt
      do ix=1,Nx
      do iq=1,NqE

      read(2,*)a,Q2E_array(iq),a,
     >Escript_Im_array(it,ix,iq),Escript_Re_array(it,ix,iq)

      enddo
      enddo
      enddo

      close(2)

        else

      if (aJu.eq.0.2d0) then
      open(3,file='Escript_dual_guidal_Ju02.dat',status='unknown')

      Nt=13
      Nx=27
      NqE=10     

      do it=1,Nt
      do ix=1,Nx
      do iq=1,NqE

      read(3,*)a,Q2E_array(iq),a,
     >Escript_Im_array(it,ix,iq),Escript_Re_array(it,ix,iq)

      enddo
      enddo
      enddo
      close(3)

        else

      if (aJu.eq.0.4d0) then
      open(4,file='Escript_dual_guidal_Ju04.dat',status='unknown')

      Nt=13
      Nx=27
      NqE=10     

      do it=1,Nt
      do ix=1,Nx
      do iq=1,NqE

      read(4,*)a,Q2E_array(iq),a,
     >Escript_Im_array(it,ix,iq),Escript_Re_array(it,ix,iq)

      enddo
      enddo
      enddo
      close(4)
        else
        write(6,*) 'WRONG J_u'
        endif

        endif
        endif
c        endif
      
* 3D interpolation done separately in all three variables
      do it=1,Nt
      do ix=1,Nx

      do iq=1,Nq
       
      Q2tmp_Im(iq)=Hscript_Im_array(it,ix,iq)
      Q2tmp_Re(iq)=Hscript_Re_array(it,ix,iq)   
      enddo

      do iq=1,NqE
       
      Q2Etmp_Im(iq)=Escript_Im_array(it,ix,iq)
      Q2Etmp_Re(iq)=Escript_Re_array(it,ix,iq)   
      enddo

      call linear(Nq,Q2_array,Q2tmp_Im,Q2,xBtmp_Im(ix)) 
      call linear(Nq,Q2_array,Q2tmp_Re,Q2,xBtmp_Re(ix))   

      call linear(NqE,Q2E_array,Q2Etmp_Im,Q2,xBEtmp_Im(ix)) 
      call linear(NqE,Q2E_array,Q2Etmp_Re,Q2,xBEtmp_Re(ix)) 

      enddo

      call linear(Nx,xB_array,xBtmp_Im,xB,ttmp_Im(it))  
      call linear(Nx,xB_array,xBtmp_Re,xB,ttmp_Re(it)) 

      call linear(Nx,xB_array,xBEtmp_Im,xB,tEtmp_Im(it))  
      call linear(Nx,xB_array,xBEtmp_Re,xB,tEtmp_Re(it)) 

      enddo

      call linear(Nt,t_array,ttmp_Im,t,Hscript_Im) 
      call linear(Nt,t_array,ttmp_Re,t,Hscript_Re)  

      call linear(Nt,t_array,tEtmp_Im,t,Escript_Im) 
      call linear(Nt,t_array,tEtmp_Re,t,Escript_Re) 

      return
      end

* 1D linear interpolation
      subroutine linear(n,xa,ya,x,y)      
      implicit double precision (a-h,o-z)
      integer n,ns,i

      dimension xa(n),ya(n)

C just in case there is some rounding error

      y=0.0
      
C Later added by Tobias      
      ns=0.0
      
c      if (x.lt.xa(1)) x=xa(1)

      dif=abs(x-xa(1))

      do i=1,n-1

C Finding the closest index i

      dift=abs(x-xa(i)) 
      if (dift.le.dif) then
      ns=i
      dif=dift
      endif
      enddo     

C x could be greater or smaller than xa(i)


      if (x.gt.xa(ns)) then   

      y1=ya(ns)
      y2=ya(ns+1)
      x1=xa(ns)
      x2=xa(ns+1) 

      y=((y1-y2)*x+(y2*x1-y1*x2))/(x1-x2)

      else

      y1=ya(ns-1)
      y2=ya(ns)
      x1=xa(ns-1)
      x2=xa(ns) 

      y=((y1-y2)*x+(y2*x1-y1*x2))/(x1-x2)   

      endif

      return
      end
      

C***********************************************************************
     
C Integration

      SUBROUTINE GAUSAB( X, W, A, B, NPT )

C=======================================================================
C                               /b
C     Gaussian quadratures for  | f(x)dx.   NPT must be even & <100.
C                              /a
C
C=======================================================================

      implicit double precision (a-h,o-z)
      dimension X(1), W(1)
      
    
      COMMON / GAUSCM / XX(100), WW(100)
C-----------------------------------------------------------------------
      NPT2 = NPT/2

      IF( A .EQ. 0. .AND. B .GT. .5E20 ) THEN
      CALL GAUS(NPT,1)
      DO 5 N = 1, NPT
      X(N) = XX(N)
      W(N) = WW(N)
5     CONTINUE
      RETURN
      END IF

      CALL GAUS(NPT,0)

      C1 = (B-A)/2.
      C2 = (B+A)/2.

      DO 10 N = 1, NPT2
      M = NPT2 + 1 - N
      X(N) = - XX(M)*C1 + C2
      W(N) =   WW(M)*C1
10    CONTINUE

      DO 20 N = NPT2+1, NPT
      M = N - NPT2
      X(N) = XX(M)*C1 + C2
      W(N) = WW(M)*C1
20    CONTINUE

      RETURN

      END
C=======================================================================
        SUBROUTINE GAUS(NN,ITYPE)
C
C       STANDARD SETTINGS ARE: IALF=IBTA=0,0<NN<100,
C               ITYPE=0 : -1 TO +1 POINTS
C               ITYPE=1 :  0 TO INFINITY
C
      implicit double precision (a-h,o-z)

      DATA IALF, IBTA / 0, 0 /
C***********************************************************************
C
C     GAUJAC COMPUTES GAUSS - JACOBI INTEGRATION WEIGHTS AND NODES
C
C***********************************************************************
C
      DIMENSION X(100),A(100),B(100),C(100)
      DIMENSION XX(100), WW(100)
      DIMENSION G(100)
C
        COMMON/GAUSCM/XX,WW
C
      PI=3.141592653589793238D0
C
      ISUM=IALF+IBTA
      IDIF=IBTA-IALF
      FNUM=ISUM*IDIF
      ALF=IALF
      BTA=IBTA
C
C     CALCULATE COEFFICIENTS REQUIRED BY JACOBI
C
      DO 20 I=1,100
      I2=I+I
      IM=I-1
      DEN=(ISUM+I2)*(ISUM+I2-2)
      IF(ISUM.EQ.0) GO TO 67
      B(I)=FNUM/DEN
      GO TO 68
67    B(I)=0.D0
68    FNUMP=4*IM*(IALF+IM)*(IBTA+IM)*(ISUM+IM)
      DENP=(ISUM+I2-1)*(ISUM+I2-2)**2*(ISUM+I2-3)
      IF(((ISUM.EQ.0).OR.(ISUM.EQ.1)).AND.(I.EQ.1)) GO TO 69
      C(I)=FNUMP/DENP
      GO TO 20
69    C(I)=0.D0
20    CONTINUE

C-----------------------------------------------------------------------
C     For outputting quadratures
C-----------------------------------------------------------------------
C      TYPE 34
C34    FORMAT(1X,'FILENAME FOR INTERMEDIATE RESULTS =? (A10)')
C      ACCEPT 35,FNAMX
C35    FORMAT(A10)
C      OPEN(UNIT=3,FILE=FNAMX,STATUS='NEW')
C-----------------------------------------------------------------------

      CALL JACOBI(NN,X,G,ALF,BTA,B,C,EPS,CSX,CSA,TSX,TSA)

C-----------------------------------------------------------------------
C     For outputting quadratures
C-----------------------------------------------------------------------
C      TYPE 70
C70    FORMAT(1X,'OUTPUT FILENAME ? (A10)')
C      ACCEPT 71,FNAM
C71    FORMAT(A10)
C      OPEN(UNIT=7,FILE=FNAM,STATUS='NEW')
C-----------------------------------------------------------------------

C     OUTPUT DATA STATEMENT OF WEIGHTS AND NODES
C
      IF(ITYPE.EQ.0) GO TO 130
      DO 100 I=1,NN
      II=NN+1-I
C     XX(I)=(1.0D+00+X(II))/(1.0D+00-X(II))
C     WW(I)=2.0D+00*G(II)/((1.0D+00-X(II))**(IALF+2)*
C    1     (1.0D+00+X(II))**IBTA)
      ZZ=PI*(1.0D+00+X(II))/4.0D+00
      XX(I)=SIN(ZZ)/COS(ZZ)
      WW(I)=G(II)*PI*0.25D+00/(COS(0.25D+00*PI*(1.0D+00
     1      +X(II)))**2)

C-----------------------------------------------------------------------
C      WRITE(7,120)I,I,XX(I),WW(I)
120   FORMAT(6X,6HDATAX(,I2,6H,M),W(,I2,4H,M)/,D22.15,1H,,
     1      D22.15,1H/)
C-----------------------------------------------------------------------

100   CONTINUE
        RETURN
 130  CONTINUE
      NI=NN/2
      DO 140 I=1,NI
      II=NI+1-I
      XX(I)=X(II)
      WW(I)=G(II)

C-----------------------------------------------------------------------
C      WRITE(7,120)I,I,XX(I),WW(I)
C-----------------------------------------------------------------------

140   CONTINUE
      RETURN
      END


      SUBROUTINE JACOBI(NN,X,A,ALF,BTA,B,C,EPS,CSX,CSA,TSX,TSA)
c      IMPLICIT REAL*8 (A-H,O-Z)
        implicit double precision (a-h,o-z)
C


C***********************************************************************
C
C     CALCULATES THE ZEROS X(I) OF THE NN-TH ORDER JACOBI POLYNOMIAL
C     PN(ALF,BTA) FOR THE SEGMENT (-1,1)
C     THE LARGEST ZERO WILL BE STORED IN X(1).
C     ALSO CALCULATES THE CORRESPONDING COEFFICIENTS A(I) OF THE
C     NN-TH ORDER GAUSS-JACOBI QUADRATURE FORMULA OF DEGREE 2*NN-1.
C     THIS SUBROUTINE MUST BE GIVEN THE COEFFICIENTS:
C
C                (ALF+BTA)(BTA-ALF)
C        B(N) = -----------------------------
C               (ALF+BTA+2N)(ALF+BTA+2N-2)
C
C                4(N-1)(ALF+N-1)(BTA+N-1)(ALF+BTA+N-1)
C        C(N) = ---------------------------------------------
C               (ALF+BTA+2N-1)(ALF+BTA+2N-2)**2(ALF+BTA+2N-3)
C
C
C     IN THE RECURSION RELATION
C
C        P(N) = (X-B(N))*P(N-1)-C(N)*P(N-2)
C
C     FOR ALL N LESS THAN OR EQUAL TO THE HIGHEST DEGREE NN.
C
C        CSX = CALC SUM X(I)      TSX = TRUE SUM X(I)
C        CSA = CALC SUM A(I)      TSA = TRUE SUM A(I)
C
C***********************************************************************
C
      DIMENSION X(100),A(100),B(100),C(100)
      FN=NN
      CSX=0.D0
      CSA=0.D0
      BETA=EXP(FLGAMA(ALF+1.D0)+FLGAMA(BTA+1.D0)-FLGAMA(ALF+BTA+2.D0))
      CC=2.**(ALF+BTA+1.)*BETA
      TSX=FN*(BTA-ALF)/(ALF+BTA+2.*FN)
      TSA=CC
      DO 1 J=2,NN
1     CC=CC*C(J)
      DO 12 I=1,NN
      IF(I-1)12,2,3
C        LARGEST ZERO
2     AN=ALF/FN
      BN=BTA/FN
      R1=(1.D0+ALF)*(2.78/(4.+FN*FN)+.768*AN/FN)
      R2=1.D0+1.48*AN+.96*BN+.452*AN*AN+.83*AN*BN
      XT=1.D0-R1/R2
      GO TO 11
3     IF(I-2)12,4,5
C        SECOND ZERO
4     R1=(4.1+ALF)/((1.+ALF)*(1.+.156*ALF))
      R2=1.D0+.06*(FN-8.)*(1.D0+.12*ALF)/FN
      R3=1.D0+.012*BTA*(1.D0+.25*ABS(ALF))/FN
      RATIO=R1*R2*R3
      XT=XT-RATIO*(1.D0-XT)
      GO TO 11
5     IF(I-3) 12,6,7
C        THIRD ZERO
6     R1=(1.67+.28*ALF)/(1.D0+.37*ALF)
      R2=1.D0+.22*(FN-8.D0)/FN
      R3=1.D0+8.*BTA/((6.28D0+BTA)*FN*FN)
      RATIO=R1*R2*R3
      XT=XT-RATIO*(X(1)-XT)
      GO TO 11
7     IF(NN-I-1)10,9,8
C        MIDDLE ZEROS
8     XT=3.*X(I-1)-3.*X(I-2)+X(I-3)
      GO TO 11
C        SECOND LAST ZERO
9     R1=(1.D0+.235*BTA)/(.766D0+.119*BTA)
      R2=1./(1.D0+.639*(FN-4.D0)/(1.D0+.71*(FN-4.D0)))
      R3=1./(1.D0+20.*ALF/((7.5D0+ALF)*FN*FN))
      RATIO=R1*R2*R3
      XT=XT+RATIO*(XT-X(I-2))
      GO TO 11
C        LAST ZERO
10    R1=(1.D0+.37*BTA)/(1.67D0+.28*BTA)
      R2=1./(1.D0+.22*(FN-8.D0)/FN)
      R3=1./(1.D0+8.*ALF/((6.28D0+ALF)*FN*FN))
      RATIO=R1*R2*R3
      XT=XT+RATIO*(XT-X(I-2))
C
11    CALL GSROOT(XT,NN,ALF,BTA,DPN,PN1,B,C,EPS)
      X(I)=XT
      A(I)=CC/(DPN*PN1)
C-----------------------------------------------------------------------
C      WRITE(3,20)ALF,BTA,NN,I,XT,A(I)
C-----------------------------------------------------------------------

      CSX=CSX+XT
      CSA=CSA+A(I)
12    CONTINUE

C-----------------------------------------------------------------------
C      WRITE(3,22)CSX,CSA,TSX,TSA
20    FORMAT(1X,2F6.2,2I3,2(1X,D26.18),1X,(1X,D26.18))
22    FORMAT(1H0,/,5X,'CSX =',D25.18,5X,'CSA =',D25.18,/,
     1 5X,'TSX =',D25.18,5X,'TSA =',D25.18)
C-----------------------------------------------------------------------

      RETURN
      END

      SUBROUTINE GSROOT(X,NN,ALF,BTA,DPN,PN1,B,C,EPS)
c      IMPLICIT REAL*8 (A-H,O-Z)
        implicit double precision (a-h,o-z)


C***********************************************************************
C
C     IMPROVES THE APPROXIMATE ROOT X
C     IN ADDITION WE ALSO OBTAIN:
C      DPN = DERIVATIVE OF P(N) AT X
C      PN1 = VALUE OF P(N-1) AT X
C
C***********************************************************************
C
      DIMENSION B(100),C(100)
      ITER=0
1     ITER=ITER+1
      CALL RECR(P,DP,PN1,X,NN,ALF,BTA,B,C)
      D=P/DP
      X=X-D
      IF(ABS(D)-EPS)3,3,2
2     IF(ITER-10)1,3,3
3     DPN=DP
      RETURN
      END

      SUBROUTINE RECR(PN,DPN,PN1,X,NN,ALF,BTA,B,C)
c      IMPLICIT REAL*8 (A-H,O-Z)
        implicit double precision (a-h,o-z)


      DIMENSION B(100),C(100)
      P1=1.D0
      P=X+(ALF-BTA)/(ALF+BTA+2.D0)
      DP1=0.D0
      DP=1.D0
      DO 1 J=2,NN
      Q=(X-B(J))*P-C(J)*P1
      DQ=(X-B(J))*DP+P-C(J)*DP1
      P1=P
      P=Q
      DP1=DP
      DP=DQ
1     CONTINUE
      PN=P
      DPN=DP
      PN1=P1
      RETURN
      END

       double precision FUNCTION FLGAMA(W)
c      IMPLICIT REAL*8 (A-H,O-Z)
        implicit double precision (a-h,o-z)

C
C***********************************************************************
C
C     CALCULATES LOG(BASE E)GAMMA(W) FOR W REAL AND GAMMA(W) POSITIVE.
C     USES STIRLING'S APPROXIMATION
C     ACCURATE TO ABOUT 12 SIGNIFICANT PLACES
C
C***********************************************************************
C
      PI=3.141592653589793238D0
      X=W
      M=0
      FK=-1.D0
      IF(X-.5D0)1,1,2
C        W LESS EQ .5
1     M=1
      XPI=X*PI
      X=1.D0-X
2     FK=FK+1.D0
      IF(X+FK-6.D0)2,2,3
3     Z=X+FK
      ZZ=Z*Z
C        LOG GAMMA(Z), Z GREATER 6.
      Y=(Z-.5)*LOG(Z)-Z+.9189385332047+(((((((-10861851./ZZ
     1 +2356200.)/ZZ-704820.)/ZZ+309400.)/ZZ-218790.)/ZZ
     2 +291720.)/ZZ-1021020.)/ZZ+30630600.)/Z/367567200.
      IF(FK)6,6,4
4     IK=FK
      DO 5 I=1,IK
      FK=FK-1.
5     Y=Y-LOG(X+FK)
6     IF(M)7,11,7
7     P=PI/SIN(XPI)
      IF(P)8,8,10
8     WRITE(6,9)W
9     FORMAT(2X,6HGAMMA(D11.4,13H) IS NEGATIVE)
      Y=0.
      GO TO 11
10    Y=LOG(P)-Y
11    FLGAMA=Y
      RETURN
      END
c========

